#include <typeinfo.h>
class SpriteAppWin {
  friend class Sprite;
protected:
  int renback;
  int quitting;
  Window wnd;
  Display *display;
  Window root;
  int screen;
  Pixmap Backpxm,Bufpxm;
  Sprite *first;
  Sprite *_2bnuked;
  int cx,cy;
  char *name,*title;
  Colormap cmap;
  GC bufgc;
  static void _SpriteThread(void *);
  void _SpriteLoop();
  virtual void ProcessEvent(XEvent *);
public:
  SpriteAppWin(Display *dpy,char * _title,int _cx,int _cy);
  ~SpriteAppWin();
  void Run();
  void Quit();
  int LoadPixmap(char **data,Pixmap *pm_return,Pixmap *mask_return);
  void AddSprite(Sprite *s);
  void DeleteSprite(Sprite *s);
  Sprite *LastSprite();
  void PlaceSpriteBehind(Sprite *s1,Sprite *s2);
  void SetRenderBack(int rb) {renback = rb;}
  int RenderBack() {return renback;}
  Display *theDisplay() {return display;}
  Window theWindow() {return wnd;}
  Pixmap Background() {return Backpxm;}
  Pixmap Buffer() {return Bufpxm;}
  int XSize() {return cx;}
  int YSize() {return cy;}
};

class Sprite {
  friend class SpriteAppWin;
protected:
  SpriteAppWin *host;
  Sprite *next,*prev;
  float x,y,vx,vy;
  int cx,cy,px,py;
  Pixmap pxm,maskpxm;
  GC sprgc;
  XColor key;
  int auto_hittest;
  virtual void RenderSprite(Drawable d);
  void CreateSpriteBitmaps(char **data);
  void CreateSpriteGC();
public:
  Sprite(SpriteAppWin *sw,float _x,float _y,char **xpm);
  Sprite(SpriteAppWin *sw,float _x,float _y,Pixmap p,Pixmap mp);
  ~Sprite();
  virtual void MoveSprite(float newx,float newy);
  void SetSpriteMotion(float _vx,float _vy);
  virtual void ChangeSpriteShape(char **data);
  virtual void ChangeSpriteShape(Pixmap p,Pixmap mp);
  void PlaceSpriteBehind(Sprite *s) {host->PlaceSpriteBehind(this,s);}
  void SetAutoHitTest(int n) {auto_hittest = n;}
  int AutoHitTest() {return auto_hittest;}
  int SpriteHitTest(Sprite *s);
  virtual void OnHitTest(Sprite *);
  void Nuke();
  float XPos() {return x;}
  float YPos() {return y;}
  int XSize() {return cx;}
  int YSize() {return cy;}
  float XVel() {return vx;}
  float YVel() {return vy;}
  Sprite *Next() {return next;}
  Sprite *Prev() {return prev;}
  SpriteAppWin *Host() {return host;}
};
